﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exemplo_DFW
{
    public partial class formSAT : Form
    {
        int iRet = 0;
        string strMsg = "";
        public formSAT()
        {
            InitializeComponent();
        }

        private void btnFechar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnExecutar1_Click(object sender, EventArgs e)
        {
            iRet = 0;
            strMsg = "";
            if (cbxCfgRetStatus.SelectedIndex == 0) // rAvisoErro_SAT_Daruma(strCodigo, strMensagem)
            {
                StringBuilder strCodigo = new StringBuilder(5);
                StringBuilder strMensagem = new StringBuilder(500);
                iRet = Declaracoes.rAvisoErro_SAT_Daruma(strCodigo, strMensagem);
                if (iRet == 1)
                {
                    MessageBox.Show("Método executado com sucesso.", "Exemplo_DFW C# - SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    tbxParam0.Enabled = true;
                    tbxParam1.Enabled = true;
                    tbxParam0.Text = strCodigo.ToString();
                    tbxParam1.Text = strMensagem.ToString();
                }

                else
                    MessageBox.Show("Ocorreu erro ao ler Aviso/Erro, erro retornado: [" + iRet.ToString() + "]", "Exemplo_DFW - SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCfgRetStatus.SelectedIndex == 1) // rCFVerificarStatus_SAT_Daruma()
            {
                iRet = Declaracoes.rCFVerificarStatus_SAT_Daruma();
                switch (iRet)
                {
                    case 0: strMsg = "[0] Nenhuma venda aberta"; break;
                    case 1: strMsg = "[1] Venda aberta sem itens vendidos"; break;
                    case 2: strMsg = "[2] Venda aberta e itens vendidos"; break;
                    case 3: strMsg = "[3] Venda totalizada"; break;
                    case 4: strMsg = "[4] Venda totalmente paga"; break;
                    case 5: strMsg = "[5] Venda encerrada"; break;
                    case 6: strMsg = "[6] Venda cancelada"; break;
                    default: strMsg = "Retornou: [" + iRet.ToString() + "] código de retorno não mapeado no exemplo"; break;
                }
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;

            }
            else if (cbxCfgRetStatus.SelectedIndex == 2) // rConsultarStatus_SAT_Daruma(strRetornoSAT)
            {
                StringBuilder strRetornoSAT = new StringBuilder();
                strRetornoSAT.Length = 500;
                iRet = Declaracoes.rConsultarStatus_SAT_Daruma(strRetornoSAT);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam0.Text = strRetornoSAT.ToString();
                }

            }
            else if (cbxCfgRetStatus.SelectedIndex == 3) // rConsultarStatusEspecifico_SAT_Daruma(strCampo, strRetornoSAT)
            {
                string strIndice = "";
                StringBuilder strRetornoSAT = new StringBuilder();
                iRet = Declaracoes.rConsultarStatusEspecifico_SAT_Daruma(strIndice, strRetornoSAT);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam1.Enabled = true;
                    tbxParam1.Text = strRetornoSAT.ToString();
                }
            }
            else if (cbxCfgRetStatus.SelectedIndex == 4) // rConsultarArqCopSeguranca_SAT_Daruma(strArqCopSegRet)
            {
                StringBuilder strArquivo = new StringBuilder();
                iRet = Declaracoes.rConsultarArqCopSeguranca_SAT_Daruma(strArquivo);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam0.Text = strArquivo.ToString();
                }

            }
            else if (cbxCfgRetStatus.SelectedIndex == 5) // rInfoEstendida_SAT_Daruma(strIndice, strRetorno)
            {
                StringBuilder strRetorno = new StringBuilder();
                string strIndice = tbxParam0.Text;
                iRet = Declaracoes.rInfoEstendida_SAT_Daruma(strIndice, strRetorno);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam1.Enabled = true;
                    tbxParam1.Text = strRetorno.ToString();
                }
            }
            else if (cbxCfgRetStatus.SelectedIndex == 6) //rNumDocsContingencia_SAT_Daruma()
            {
                iRet = Declaracoes.rNumDocsContingencia_SAT_Daruma();
                if (iRet > 0)
                    strMsg = "Número de arquivo SAT de contingência disponiveis para envio: " + iRet.ToString() + ".";
                else if (iRet == 0)
                    strMsg = "Não há arquivos de contingênca SAT no momento.";
                else
                    strMsg = "Erro [" + iRet.ToString() + "] retornado no método.";
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;

            }
            else if (cbxCfgRetStatus.SelectedIndex == 7) //rVerificarComunicacao_SAT_Daruma()
            {
                iRet = Declaracoes.rVerificarComunicacao_SAT_Daruma();
                switch (iRet)
                {
                    case 1: strMsg = "[1] Comunicação SAT OK!"; break;
                    case 0: strMsg = "[0] Erro na execução do método."; break;
                    case -6: strMsg = "[-6] TimeOut, erro de comunicação com o SAT. Não houve resposta no tempo esperado."; break;
                    case -7: strMsg = "[-7] Erro de comunicação com o SAT. Verifique se a porta de comunicação do SAT está disponível."; break;
                    case -140: strMsg = "[-140] Biblioteca dllsat.dll não encontrada/ carregada."; break;
                    case 8098: strMsg = "[8098] SAT em processamento. Tente novamente."; break;
                    case 8099: strMsg = "[8099] Erro desconhecido, retornado pelo SAT."; break;
                    default: strMsg = "Retornou: [" + iRet.ToString() + "] código de retorno não mapeado no exemplo"; break;
                }
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 8) //regAlterarValor_SAT_Daruma(strTagSAT, strValorTagSAT)
            {
                string strTag = tbxParam0.Text;
                string strValor = tbxParam1.Text;
                iRet = Declaracoes.regAlterarValor_SAT_Daruma(strTag, strValor);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCfgRetStatus.SelectedIndex == 9) //regRetornarValor_SAT_Daruma(strTagSAT, strValorRetTagSAT)
            {
                StringBuilder strValorRet = new StringBuilder();
                strValorRet.Length = 400;
                string strTag = tbxParam0.Text;
                iRet = Declaracoes.regRetornarValor_SAT_Daruma(strTag, strValorRet);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam1.Enabled = true;
                    tbxParam1.Text = strValorRet.ToString();
                }
            }
            else if (cbxCfgRetStatus.SelectedIndex == 10) //tCFeAssociarAssinatura_SAT_Daruma(strTagsSAT)
            {
                int iRet2 = 0;
                string strTagsSAT = tbxParam0.Text;
                iRet = Declaracoes.tCFeAssociarAssinatura_SAT_Daruma(strTagsSAT);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                
            }
            else if (cbxCfgRetStatus.SelectedIndex == 11) //iReimprimirUltimoCFe_SAT_Daruma()
            {
                iRet = Declaracoes.iReimprimirUltimoCFe_SAT_Daruma();
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCfgRetStatus.SelectedIndex == 12) //iImprimirCFe_SAT_Daruma(strPathXmlSAT, strTipo)
            {
                string strPathXml = tbxParam0.Text;
                string strTipo = tbxParam1.Text;
                iRet = Declaracoes.iImprimirCFe_SAT_Daruma(strPathXml, strTipo);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCfgRetStatus.SelectedIndex == 13) //tCFeEnviar_SAT_Daruma(strTagsSAT)
            {
                int iRet2 = 0;
                string strTagsXml = tbxParam0.Text;
                iRet = Declaracoes.tCFeEnviar_SAT_Daruma(strTagsXml);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                StringBuilder strCodigo = new StringBuilder(5);
                StringBuilder strMensagem = new StringBuilder(500);
                iRet2 = Declaracoes.rAvisoErro_SAT_Daruma(strCodigo, strMensagem);
                if (iRet2 == 1)
                    MessageBox.Show("Método executado com sucesso. Aviso/Erro: [" + strCodigo + "] - " + strMensagem, "Exemplo_DFW C# - SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show("Ocorreu erro ao ler Aviso/Erro, erro retornado: [" + iRet.ToString() + "]", "Exemplo_DFW - SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            else if (cbxCfgRetStatus.SelectedIndex == 14) //tEnviarContingencia_SAT_Daruma (iNumDocs)
            {
                int iNumDocs = Convert.ToInt32(tbxParam0.Text);
                iRet = Declaracoes.tEnviarContingencia_SAT_Daruma(iNumDocs);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCfgRetStatus.SelectedIndex == 15) //tEnviarXML_SAT_Daruma (strPathXML)
            {
                string strCaminhoXml = tbxParam0.Text;
                iRet = Declaracoes.tEnviarXML_SAT_Daruma(strCaminhoXml);
                strMsg = Declaracoes.TrataRetorno_SAT(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        private void cbxCfgRetStatus_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxCfgRetStatus.SelectedIndex == 0) // rAvisoErro_SAT_Daruma(strCodigo, strMensagem)
            {
                lblParam0.Text = "Codigo retornado:";
                lblParam1.Text = "Mensagem retornada:";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 1) // rCFVerificarStatus_SAT_Daruma()
            {
                lblParam0.Text = "Status venda SAT retornado:";
                lblParam1.Text = "-:";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 2) // rConsultarStatus_SAT_Daruma(strRetornoSAT)
            {
                lblParam0.Text = "Status do SAT retornado:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 3) // rConsultarStatusEspecifico_SAT_Daruma(strCampo, strRetornoSAT)
            {
                lblParam0.Text = "Índice da informação desejada (1 até 25):";
                lblParam1.Text = "Status do SAT retornado:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 4) // rConsultarArqCopSeguranca_SAT_Daruma(strArqCopSegRet)
            {
                lblParam0.Text = "Local e nome do arquivo ref. ultima venda emitida: ";
                lblParam1.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 5) // rInfoEstendida_SAT_Daruma(strIndice, strRetorno)
            {
                lblParam0.Text = "Indice da informação desejada (1 até 13 - depende do ultimo comando):";
                lblParam1.Text = "Informação retornada:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 6) //rNumDocsContingencia_SAT_Daruma()
            {
                lblParam0.Text = "Número de arquivos SAT em Contingência retornado:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 7) //rVerificarComunicacao_SAT_Daruma()
            {
                lblParam0.Text = "rVerificarComunicacao_SAT retornou:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 8) //regAlterarValor_SAT_Daruma(strTagSAT, strValorTagSAT)
            {
                lblParam0.Text = "Configuração a ser alterada:";
                lblParam1.Text = "Valor a ser configurado:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 9) //regRetornarValor_SAT_Daruma(strTagSAT, strValorRetTagSAT)
            {
                lblParam0.Text = "Configuração a ser lida:";
                lblParam1.Text = "Valor retornado:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 10) //tCFeAssociarAssinatura_SAT_Daruma(strTagsSAT)
            {
                lblParam0.Text = "Tags Assinatura (cnpjEmit, cnpjIdent e signAC):";
                lblParam1.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 11) //iReimprimirUltimoCFe_SAT_Daruma()
            {
                lblParam0.Text = "-";
                lblParam1.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;

            }
            else if (cbxCfgRetStatus.SelectedIndex == 12) //iImprimirCFe_SAT_Daruma(strPathXmlSAT, strTipo)
            {
                lblParam0.Text = "Caminho do XML para impressão:";
                lblParam1.Text = "Tipo do documento pra impressão (1-CFe ou 2-Cancelamento):";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 13) //tCFeEnviar_SAT_Daruma(strTagsSAT)
            {
                lblParam0.Text = "Dados da venda em XML:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 14) //tEnviarContingencia_SAT_Daruma (iNumDocs)
            {
                lblParam0.Text = "Numero de arquivos para envio:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
            else if (cbxCfgRetStatus.SelectedIndex == 15) //tEnviarXML_SAT_Daruma (strPathXML)
            {
                lblParam0.Text = "Caminho e nome do XML para Armazenamento:";
                lblParam1.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            tbxParam0.Text = "";
            tbxParam1.Text = "";
        }

        private void btnAbrir_Click(object sender, EventArgs e)
        {
            string strCPF = tbxCPF.Text;
            string strNome = tbxNome.Text;
            string strEnd = tbxEnd.Text;
            iRet = Declaracoes.aCFAbrir_SAT_Daruma(strCPF, strNome, strEnd);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFAbrir_SAT_Daruma: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnConfImposto_Click_1(object sender, EventArgs e)
        {
            string strTipo = tbxTipo.Text;
            string strParametros = tbxParametros.Text;
            iRet = Declaracoes.aCFConfImposto_SAT_Daruma(strTipo, strParametros);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFConfImposto_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnVender_Click(object sender, EventArgs e)
        {
            string strAliq = tbxAliquota.Text;
            string strQtde = tbxQtde.Text;
            string strVlrUnit = tbxVlrUnitario.Text;
            string strTpDescAcres = cbxTpDescAcresc.Text;
            string strVlrDescAcres = tbxVlrDescAcresc.Text;
            string strCodigo = tbxCodItem.Text;
            string strNCM = tbxNCM.Text;
            string strCFOP = tbxCFOP.Text;
            string strMedida = tbxUnidMedida.Text;
            string strDesc = tbxDescricao.Text;
            string strMetaParam = tbxMetapatam.Text;
            iRet = Declaracoes.aCFVenderCompleto_SAT_Daruma(strAliq, strQtde, strVlrUnit, strTpDescAcres, strVlrDescAcres, strCodigo, strNCM, strCFOP, strMedida, strDesc, strMetaParam);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFVenderCompleto_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnVlrImp_Click(object sender, EventArgs e)
        {
            string strValor = tbxVlrImp.Text;
            iRet = Declaracoes.aCFValorLeiImposto_SAT_Daruma(strValor);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFValorLeiImposto_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnTotaliza_Click(object sender, EventArgs e)
        {
            string strTpDescAcreTot = cbxTpDescAcreTot.Text;
            string strVlrDescAcresTot = tbxVlrDescAcreTot.Text;
            iRet = Declaracoes.aCFTotalizar_SAT_Daruma(strTpDescAcreTot, strVlrDescAcresTot);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFTotalizar_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnCancelarPgto_Click(object sender, EventArgs e)
        {
            int iIndicePgto = Convert.ToInt32(tbxIndicePgto.Text);
            iRet = Declaracoes.aCFeCancelarFormaPagamento_SAT_Daruma(iIndicePgto);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFCancelarFormaPagamento_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnEfetuarPgto_Click(object sender, EventArgs e)
        {
            string strFormaPgto = cbxFormaPgto.Text;
            string strValorPgto = tbxVlrPgto.Text;
            string strCodCred = tbxCodCred.Text;
            iRet = Declaracoes.aCFEfetuarPagamento_SAT_Daruma(strFormaPgto, strValorPgto, strCodCred);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFEfetuarPagamento_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnEstornar_Click(object sender, EventArgs e)
        {
            string strFormaEstorno = cbxFormaEstorno.Text;
            string strNovaForma = cbxNovaForma.Text;
            string strValorForma = tbxValorFPgto.Text;
            iRet = Declaracoes.aCFEstornarPagamento_SAT_Daruma(strFormaEstorno, strNovaForma, strValorForma);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFEstornarPagamento_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnEncerrar_Click(object sender, EventArgs e)
        {
            string strInfAdic = tbxInfoAdic.Text;
            iRet = Declaracoes.tCFEncerrar_SAT_Daruma(" ", strInfAdic);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno tCFEncerrar_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            cbxCfgRetStatus.SelectedIndex = 0;
            btnExecutar1.PerformClick();
        }

        private void btnCancItem_Click(object sender, EventArgs e)
        {
            int iNumItem = Convert.ToInt32(tbxItem.Text);
            iRet = Declaracoes.aCFeCancelarItem_SAT_Daruma(iNumItem);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno aCFeCancelarItem_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnCancParam_Click(object sender, EventArgs e)
        {
            string strIdConsumidor = tbxIdConsumidor.Text;
            string strChaveConsulta = tbxChaveConsulta.Text;
            iRet = Declaracoes.tCFeCancelarParametrizado_SAT_Daruma(strIdConsumidor, strChaveConsulta);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno tCFeCancelarParametrizado_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            cbxCfgRetStatus.SelectedIndex = 0;
            btnExecutar1.PerformClick();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string strPathArq = tbxPathArquivo.Text;
            int iNumVia = Convert.ToInt32(tbxNumVias.Text);
            int iCortar = Convert.ToInt32(cbxCorte.SelectedIndex);
            int iTravar = Convert.ToInt32(cbxTravar.SelectedIndex);
            iRet = Declaracoes.iTEFImprimirResposta_SAT_Daruma(strPathArq, iNumVia, iCortar, iTravar);
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno iTEFImprimirResposta_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnCancelar_Click(object sender, EventArgs e)
        {
            iRet = Declaracoes.tCFeCancelar_SAT_Daruma();
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno tCFeCancelar_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnVendaSAT_Click(object sender, EventArgs e)
        {
            int iQtdItem = Convert.ToInt32(tbxQtdItens.Text);
            int iNumVenda = Convert.ToInt32(tbxQtdCupons.Text);
            int iItens = 0;
            int iCupom = 0;
            string desc = "";
            while (iCupom < iNumVenda)
            {
                iRet = Declaracoes.aCFAbrir_SAT_Daruma("", "", "");
                if (iRet > 0)
                {
                    for (iItens = 1; iItens <= iQtdItem; iItens++)
                    {
                        Declaracoes.aCFConfImposto_SAT_Daruma("ICMS00", "0;00;");
                        Declaracoes.aCFConfImposto_SAT_Daruma("PISNT", "08;");
                        Declaracoes.aCFConfImposto_SAT_Daruma("COFINSNT", "08;");
                        desc = "Teste de Venda Item " + iItens.ToString();
                        Declaracoes.aCFVenderCompleto_SAT_Daruma("07,00", "1,00", "1,00", "D$", "0,00", "1234", "18063210", "5102", "UND", desc, "CEST=1705700;cEAN=7896022204969;");
                    }
                    Declaracoes.aCFTotalizar_SAT_Daruma("D$", "0,00");
                    Declaracoes.aCFEfetuarPagamento_SAT_Daruma("Dinheiro", iQtdItem.ToString()+",00", "");
                    iRet = Declaracoes.tCFEncerrar_SAT_Daruma("", "Teste de Venda Bufferizada SAT. IT FAST Automação Comercial - Exemplo C#.");
                }
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                if (iRet < 1) iCupom = iNumVenda;

                iCupom++;
            }
            MessageBox.Show("Teste de venda retornou: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
            cbxCfgRetStatus.SelectedIndex = 0;
            btnExecutar1.PerformClick();
        }

        private void btnCancelarSAT_Click(object sender, EventArgs e)
        {
            iRet = Declaracoes.tCFeCancelar_SAT_Daruma();
            strMsg = Declaracoes.TrataRetorno_SAT(iRet);
            MessageBox.Show("Retorno tCFeCancelar_SAT: " + strMsg, "TrataRetorno_SAT", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

    }
}
